const webpack = require("webpack");
const path = require("path");
const resolve = dir => path.join(__dirname, dir);
const AddAssetHtmlPlugin = require("add-asset-html-webpack-plugin");
const config = {
  chainWebpack: config => {
    config.plugin("AddAssetHtmlPlugin").use(
      new AddAssetHtmlPlugin({
        // SDK可以在index.html里面引入，也可以在vue.config.js里面引入，
        // 若在index.html引入，打包时需要手动拷贝SDK文件，在vue.config.js内用插件引入则可以直接将SDK打包到项目中
        // 无论使用何种方式引入，都需要能全局调用
        filepath: resolve("/src/SDK/RTCSDKV2.min.js")
      })
    );
  }
};

module.exports = config;
